# git-push(1) Manual Page

## NAME

git-push - Update remote refs along with associated objects

## SYNOPSIS

git-push [--all] [--tags] [--receive-pack=<git-receive-pack>] [--repo=all] [-f | --force] [-v] [<repository> <refspec>…]

## DESCRIPTION

Updates remote refs using local refs, while sending objects necessary to complete the given refs.

You can make interesting things happen to a repository every time you push into it, by setting up hooks there. See documentation for git-receive-pack(1).

## OPTIONS

<repository>

  The "remote" repository that is destination of a push operation. See the section GIT URLS below.

<refspec>

  The canonical format of a <refspec> parameter is `+?<src>:<dst>`; that is, an optional plus `+`, followed by the source ref, followed by a colon `:`, followed by the destination ref.

  The <src> side can be an arbitrary "SHA1 expression" that can be used as an argument to `git-cat-file -t`. E.g. `master~4` (push four parents before the current master head).

  The local ref that matches <src> is used to fast forward the remote ref that matches <dst>. If the optional plus `+` is used, the remote ref is updated even if it does not result in a fast forward update.

  Note: If no explicit refspec is found, (that is neither on the command line nor in any Push line of the corresponding remotes file---see below), then all the refs that exist both on the local side and on the remote side are updated.

  `tag <tag>` means the same as `refs/tags/<tag>:refs/tags/<tag>`.

  A parameter <ref> without a colon is equivalent to <ref>`:`<ref>, hence updates <ref> in the destination from <ref> in the source.

  Pushing an empty <src> allows you to delete the <dst> ref from the remote repository.

--all

  Instead of naming each ref to push, specifies that all refs be pushed.

--tags

  All refs under `$GIT_DIR/refs/tags` are pushed, in addition to refspecs explicitly listed on the command line.

--receive-pack=<git-receive-pack>

  Path to the git-receive-pack program on the remote end. Sometimes useful when pushing to a remote repository over ssh, and you do not have the program in a directory on the default $PATH.

--exec=<git-receive-pack>

  Same as --receive-pack=<git-receive-pack>.

-f, --force

  Usually, the command refuses to update a remote ref that is not a descendant of the local ref used to overwrite it. This flag disables the check. This can cause the remote repository to lose commits; use it with care.

--repo=<repo>

  When no repository is specified the command defaults to "origin"; this overrides it.

--thin, --no-thin

  These options are passed to `git-send-pack`. Thin transfer spends extra cycles to minimize the number of objects to be sent and meant to be used on slower connection.

-v

  Run verbosely.

## GIT URLS

One of the following notations can be used to name the remote repository:

- rsync://host.xz/path/to/repo.git/

- http://host.xz/path/to/repo.git/

- https://host.xz/path/to/repo.git/

- git://host.xz/path/to/repo.git/

- git://host.xz/~user/path/to/repo.git/

- ssh://[user@]host.xz/path/to/repo.git/

- ssh://[user@]host.xz/~user/path/to/repo.git/

- ssh://[user@]host.xz/~/path/to/repo.git

SSH is the default transport protocol. You can optionally specify which user to log-in as, and an alternate, scp-like syntax is also supported. Both syntaxes support username expansion, as does the native git protocol. The following three are identical to the last three above, respectively:

- [user@]host.xz:/path/to/repo.git/

- [user@]host.xz:~user/path/to/repo.git/

- [user@]host.xz:path/to/repo.git

To sync with a local directory, use:

- /path/to/repo.git/

## REMOTES

In addition to the above, as a short-hand, the name of a file in `$GIT_DIR/remotes` directory can be given; the named file should be in the following format:

            URL: one of the above URL format
            Push: <refspec>
            Pull: <refspec>

Then such a short-hand is specified in place of <repository> without <refspec> parameters on the command line, <refspec> specified on `Push:` lines or `Pull:` lines are used for `git-push` and `git-fetch`/`git-pull`, respectively. Multiple `Push:` and `Pull:` lines may be specified for additional branch mappings.

Or, equivalently, in the `$GIT_DIR/config` (note the use of `fetch` instead of `Pull:`):

            [remote "<remote>"]
                    url = <url>
                    push = <refspec>
                    fetch = <refspec>

The name of a file in `$GIT_DIR/branches` directory can be specified as an older notation short-hand; the named file should contain a single line, a URL in one of the above formats, optionally followed by a hash `#` and the name of remote head (URL fragment notation). `$GIT_DIR/branches/<remote>` file that stores a <url> without the fragment is equivalent to have this in the corresponding file in the `$GIT_DIR/remotes/` directory.

            URL: <url>
            Pull: refs/heads/master:<remote>

while having `<url>#<head>` is equivalent to

            URL: <url>
            Pull: refs/heads/<head>:<remote>

## Author

Written by Junio C Hamano <junkio@cox.net>, later rewritten in C by Linus Torvalds <torvalds@osdl.org>

## Documentation

Documentation by Junio C Hamano and the git-list <git@vger.kernel.org>.

## GIT

Part of the git(7) suite